Attribute VB_Name = "Module1"
Private Declare Function _
AllocConsole Lib "kernel32" () As Long
'This will create a console window in which we can print and receive input. This
'console window - this is important to remember - is a process controlled by the '
'operating system. Think of all operations that we perform on it as "requests" ('
'and these requests can be denied). Since it is a process, it must always be destroyed
'when we are done with it, or before the application terminates. We destroy the console process with the FreeConsole function.

Private Declare Function _
FreeConsole Lib "kernel32" () As Long
Private Declare Function _
GetStdHandle Lib "kernel32" (ByVal _
nStdHandle As Long) As Long
'The argument nStdHandle determines which handle it returns. The mnemonic constants have three possible values to pass are:

Private Const STD_INPUT_HANDLE = -10&
Private Const STD_OUTPUT_HANDLE = -11&
Private Const STD_ERROR_HANDLE = -12&
Private Declare Function _
SetConsoleTitle Lib "kernel32" Alias _
"SetConsoleTitleA" (ByVal lpConsoleTitle _
As String) As Long
'This is fairly self-explanatory. Notice that this function is one of the very few that
'don't require you to pass a handle as an argument. All that is passed in this function
'is a string that contains the new title for the console window.

'Making Your Output More Colorful

'If you were to just call the WriteConsole function, your output would always appear in
'the same bland gray text. You can change the color of the text printed by subsequent
'calls to WriteOutput by calling the SetConsoleTextAttribute function.

Private Declare Function _
SetConsoleTextAttribute Lib "kernel32" _
(ByVal hConsoleOutput As Long, _
ByVal wAttributes As Long) As Long

' These values are passed in the wAttributes argument
Private Const FOREGROUND_BLUE = &H1
Private Const FOREGROUND_GREEN = &H2
Private Const FOREGROUND_RED = &H4
Private Const FOREGROUND_INTENSITY = &H8
Private Const BACKGROUND_BLUE = &H10
Private Const BACKGROUND_GREEN = &H20
Private Const BACKGROUND_RED = &H40
Private Const BACKGROUND_INTENSITY = &H80
'This is a simple function. It takes the console window's output handle and one or more color
'values. You can combine these values by using Visual Basic's bitwise Or keyword. For example,
'to create a yellow value, you would define the following constant after the ones listed above.

Private Const FOREGROUND_YELLOW = FOREGROUND_RED _
Or FOREGROUND_GREEN

'With this done, one can already write a program that brings up a console box and closes it:

'Private Declare Function _
'AllocConsole Lib "kernel32" () As Long

'Private Declare Function _
'FreeConsole Lib "kernel32" () As Long

Private Declare Function _
SetConsoleMode Lib "kernel32" _
(ByVal hConsoleOutput As Long, _
dwMode As Long) As Long

Private Declare Function _
ReadConsole Lib "kernel32" Alias _
"ReadConsoleA" (ByVal hConsoleInput As Long, _
ByVal lpBuffer As String, ByVal _
nNumberOfCharsToRead As Long, _
lpNumberOfCharsRead As Long, _
lpReserved As Any) As Long

'For SetConsoleMode (input)
Private Const ENABLE_LINE_INPUT = &H2
Private Const ENABLE_ECHO_INPUT = &H4
Private Const ENABLE_MOUSE_INPUT = &H10
Private Const ENABLE_PROCESSED_INPUT = &H1
Private Const ENABLE_WINDOW_INPUT = &H8
'For SetConsoleMode (output)
Private Const ENABLE_PROCESSED_OUTPUT = &H1
Private Const ENABLE_WRAP_AT_EOL_OUTPUT = &H2


Private Sub Main()
    AllocConsole
    FreeConsole
End Sub


